<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Scoped CSS variables and JS</title>
  </head>
  <body>
    <h2>Update CSS Variables with <span class="hl">JS</span></h2>

    <div class="controls">
      <label for="spacing">Spacing:</label>
      <input id="spacing" type="range" name="spacing" min="10" max="200" value="10" data-sizing="px" />

      <label for="blur">Blur:</label>
      <input id="blur" type="range" name="blur" min="0" max="25" value="10" data-sizing="px" />

      <label for="base">Base Color</label>
      <input id="base" type="color" name="base" value="#ffc600" />
    </div>

    <img src="https://source.unsplash.com/7bwQXzbF6KE/800x500" />

    <style>
      :root {
        --base: #ffc600;
        --spacing: 10px;
        --blur: 10px;
      }
      img {
        padding: var(--spacing);
        background: var(--base);
        filter: blur(var(--blur));
      }
      .hl {
        color: var(--base);
      }

      body {
        text-align: center;
        background: #193549;
        color: white;
        font-family: "helvetica neue", sans-serif;
        font-weight: 100;
        font-size: 50px;
      }

      .controls {
        margin-bottom: 50px;
      }

      input {
        width: 100px;
      }
    </style>

    <script>
      const controls = document.querySelector(".controls");

      function handleUpdate() {
        console.log("handleUpdate");
        // dataset 은 사용자 지정 데이터 특성(data-*)에 대한 읽기와 쓰기 접근 방법을 HTML과 DOM 양측에 제공
        // input 태그의 data-sizing 부분을 잡아낼 수 있음
        // dataset 으로 data- 로 된 부분들 다 갖고 오고, 그 중 sizing 만 갖고 옴
        // this 는 addEventListener 에서 불리는 handleUpdate 이므로, 해당 DOM 을 의미
        // px 을 갖고 위함임, color 는 px 가 없으므로, "" 으로 세팅함
        let suffix = this.dataset.sizing || "";
        // --spacing, 30px 이런 식으로 들어가게 됨
        document.documentElement.style.setProperty("--" + this.name, this.value + suffix);
      }

      // 컨트롤 주위에 마우스가 가면, 이벤트 발생
      // 사실 아래의 코드는 실험용으로 보이기 위함임
      controls.addEventListener("mousemove", function (event) {
        if (event.target.nodeName == "INPUT") {
          // 인풋 DOM 에 가면 발생하게 됨
          handleUpdate.call(event.target);
        }
      });

      // 아래의 코드만 있어도 충분히 반영 가능!
      controls.addEventListener("change", function (event) {
        if (event.target.nodeName == "INPUT") {
          handleUpdate.call(event.target);
        }
      });
    </script>
  </body>
</html>
